;/*====================================================*/
;/*  ctsr.asm       version 0.02             ::  */
;/*                                                    */
;/*  Copyright (C) 1990  -  All Rights Reserved.       */
;/*  Software Satisfaction.                            */
;/*  J.P.N.                                            */
;/*                                                    */
;/*  for Macro Assembler version 5.10                  */
;/*                                                    */
;/*  Author: Seiji Yasuda                              */
;/*                                                    */
;/*  1990.08.26 PC9801XXX version 0.01                 */
;/*  1990.09.06 Panacom/FMR version 0.02               */
;/*                                                    */
;/*====================================================*/



include	stdlib.inc


$$PC9801 	= 0
$$PANACOM	= 1



_CODE	segment
		assume	cs:_CODE, ds:_CODE, es:_CODE, ss:_CODE

		org		100h

start:
	jmp		start2

JIS			dw	7621h,7622h,7623h

	org		110h
ID			db	'TSR SET TCODE 01'
BitBuff		db	32 dup (0)
OrgBuff		db	32 * 3 dup (0)

if $$PC9801
	TimeBuff 	db	6 dup(0)
endif
if $$Panacom
	TimeBuff 	db	10 dup(0)
endif

Sec			db	-1
Font0		db	00111100b, 01000010b, 00000000b, 01000010b, 00111100b
Font1		db	00000010b, 00000010b, 00000000b, 00000010b, 00000010b
Font2		db	00111100b, 00000010b, 00111100b, 01000000b, 00111100b
Font3		db	00111100b, 00000010b, 00111100b, 00000010b, 00111100b
Font4		db	01000010b, 01000010b, 00111100b, 00000010b, 00000010b
Font5		db	00111100b, 01000000b, 00111100b, 00000010b, 00111100b
Font6		db	00111100b, 01000000b, 00111100b, 01000010b, 00111100b
Font7		db	00111100b, 01000010b, 00000000b, 00000010b, 00000010b
Font8		db	00111100b, 01000010b, 00111100b, 01000010b, 00111100b
Font9		db	00111100b, 01000010b, 00111100b, 00000010b, 00111100b

FontAdr		dw	offset Font0, offset Font1, offset Font2, offset Font3
			dw	offset Font4, offset Font5, offset Font6, offset Font7
			dw	offset Font8, offset Font9

vector	dd	?



;--------------------------------------------------------
; int 28h

Intrpt:
	$push	<ax,bx,cx,dx,si,di,ds>
	$mov	ds, cs

	lea		bx, [TimeBuff]
	call	GetDate

	mov		al, byte ptr cs:[TimeBuff+5]
	cmp		al, cs:[Sec]
	je		Intrpt4
	mov		cs:[Sec], al
	call	MakeFont
	mov		ax, cs:[JIS+4]
	lea		bx, [BitBuff]
	call	PutCharBit

	mov		al, byte ptr cs:[TimeBuff+4]
	call	MakeFont
	mov		ax, cs:[JIS+2]
	lea		bx, [BitBuff]
	call	PutCharBit

	mov		al, byte ptr cs:[TimeBuff+3]
	call	MakeFont
	mov		ax, cs:[JIS+0]
	lea		bx, [BitBuff]
	call	PutCharBit


Intrpt4:
	$pop	<ds,di,si,dx,cx,bx,ax>
	jmp		dword ptr cs:[vector]

; end of int 28h
;--------------------------------------------------------


if $$PC9801
;-------------------------------------------------;
; get PC98 timer.                                 ;
; out es:bx ... 6 dup(?)                          ;
; db  ?, ?, ?, ?, ?, ?    4bit P               ;
;     E  E  E  E  E  E                            ;
;     E  E  E  E  E  WCCCC> 10b  1b             ;
;     E  E  E  E  WCCCCCCC> 10  1             ;
;     E  E  E  WCCCCCCCCCC> 10  1             ;
;     E  E  WCCCCCCCCCCCCC> 10  1             ;
;     E  WCCCCCCCCCCCCCCCC>     j              ;
;     WCCCCCCCCCCCCCCCCCCC> 10N  1N             ;
;-------------------------------------------------;
GetDate	proc 	near
	$push	<ax,es>
	$mov	es, ds
	mov		ah, 00
	int		1ch
	$pop	<es,ax>
	ret
GetDate	endp
endif
if $$PANACOM
;-------------------------------------------------;
; get Pansonic timer.                             ;
; out es:bx ... 6 dup(?)                          ;
; db  ?, ?, ?, ?, ?, ?    4bit P               ;
;     E  E  E  E  E  E                            ;
;     E  E  E  E  E  WCCCC> 10b  1b             ;
;     E  E  E  E  WCCCCCCC> 10  1             ;
;     E  E  E  WCCCCCCCCCC> 10  1             ;
;     E  E  WCCCCCCCCCCCCC> ??    ??              ;
;     E  WCCCCCCCCCCCCCCCC> ??    ??              ;
;     WCCCCCCCCCCCCCCCCCCC> ??    ??              ;
;-------------------------------------------------;
GetDate	proc 	near
	$push	<ax,bx,cx,di>
	mov		di, bx
	mov		ah, 01
	int		96h

	mov		al, byte ptr [di+5]
	call	PackBcd
	mov		byte ptr [di+3], al

	mov		al, byte ptr [di+6]
	call	PackBcd
	mov		byte ptr [di+4], al

	mov		al, byte ptr [di+7]
	call	PackBcd
	mov		byte ptr [di+5], al

	$pop	<di,cx,bx,ax>
	ret
GetDate	endp
endif


if $$PANACOM
PackBcd	proc	near
	mov		ah,  0
	mov		bl, 10
	div		bl
	mov		cl, 4
	shl		al, cl
	or		al, ah
	ret
PackBcd	endp
endif


;-------------------------------------------------;
; make font pattarn.                              ;
; in al ... BCD  ds:[FontAdr] ?,?,? ..JIS code.   ;
;-------------------------------------------------;
MakeFont	proc	near
	mov		ah, 0
	push	ax
	and		al, 11110000b
	mov		cl, 3
	shr		al, cl
	lea		bx, [FontAdr]
	add		bx, ax
	mov		si, [bx]
	lea		di, [BitBuff+4]
	call	SetFontBuf

	pop		ax
	and		al, 00001111b
	shl		al, 1
	lea		bx, [FontAdr]
	add		bx, ax
	mov		si, [bx]
	lea		di, [BitBuff+5]
	call	SetFontBuf
	ret
MakeFont	endp

SetFontBuf	proc	near
	mov		ah, [si]
	mov		cx, 1
	call	MemSetByte
	inc		si
	mov		ah, [si]
	mov		cx, 5
	call	MemSetByte
	inc		si
	mov		ah, [si]
	mov		cx, 1
	call	MemSetByte
	inc		si
	mov		ah, [si]
	mov		cx, 5
	call	MemSetByte
	inc		si
	mov		ah, [si]
	mov		cx, 1
	call	MemSetByte
	ret
SetFontBuf	endp

MemSetByte	proc	near
	mov		byte ptr [di], ah
	add		di, 2
	loop	MemSetByte
	ret
MemSetByte	endp


if $$PC9801
;------------------------------------------------;
; << vsync check... off & on..>>  (NECPC9801XX)  ;
; -----        ------        ------              ;
;  OFF |      |      |      |      |             ;
;      #------        ------        ------       ;
;        ON                   (check # point.)   ;
;------------------------------------------------;
VsyncCheck proc near
	push	ax
VsyncCheck1:
	in		al, 60H                 ; read status.
	test	al, 00100000b
	jne		VsyncCheck1   			; check off.
VsyncCheck2:
	in		al, 60H                 ; read status.
	test	al, 00100000b
	je		VsyncCheck2  			; check on.
	pop		ax
	ret
VsyncCheck endp
endif


if $$PC9801
;------------------------------------------------;
; << put jis code's bit pattarn >> (NECPC9801XX) ;
; in  AX ...... jis code.                        ;
;     ds:bx ... db 32+2 dup(0) bit pattarn buf.  ;
;------------------------------------------------;
PutCharBit	proc near
	$push	<si,cx,bx,ax>
	mov		si, bx
	call	VsyncCheck			; vsync check.
	sub		ax, 2000h			;
	out		0a1h, al			;
	mov		al, ah				; set JIS code.
	out		0a3h, al			;
	mov		cx, 16				; loop 16 (2*16->32byte)
	xor		bl, bl
PutCharBit1:
	or		bl, 00100000b		;
	mov		al, bl				;
	out		0a5h, al			; get left 8bit pattarn.
	mov		al, [si]			;
	out		0a9h, al			;
	inc		si
	and		bl, 11011111b		;
	mov		al, bl				;
	out		0a5h, al			; get right 8bit pattarn.
	mov		al, [si]			;
	out		0a9h, al			;
	inc		si
	inc		bl
	loop	PutCharBit1
	$pop	<ax,bx,cx,si>
	ret
PutCharBit	endp
endif
if $$PANACOM
;------------------------------------------------;
; << put jis code's bit pattarn >>   (Panacom)   ;
; in  AX ...... jis code.                        ;
;     ds:bx ... db 32+2 dup(0) bit pattarn buf.  ;
;------------------------------------------------;
PutCharBit	proc near
	$push	<di,dx,bx,ax>
	mov		di, bx
	mov		bx, ax
	xchg	bh, bl
	mov		dh, 16
	mov		dl, 16
	mov		ah, 08h
	int		91h
	$pop	<ax,bx,dx,di>
	ret
PutCharBit	endp
endif


;---------------------------------------------
start2:
	$mov	ds, cs
	call	IDsearch
	cmp		ax, 0
	je		start3
	inc		ax
	$mov	bx, cs
	cmp		ax, bx
	je		start3
	$free	ax
	call	Unlink
	call	StoreFont
	$exit	0
start3:
	call	KeepFont
	call	Link
	$keep	<offset start2>


Link	proc	near
	$getvec	28h
	mov		word ptr cs:[vector+0], ax
	mov		word ptr cs:[vector+2], bx
	$setvec	28h, cs, <offset Intrpt>
	mov		dx, offset Copyright
	mov		ah, 09h
	int		21h
	ret
Link	endp


Unlink	proc	near
	$setvec	28h, <word ptr es:[vector+2]>, <word ptr es:[vector+0]>
	mov		dx, offset Msg01
	mov		ah, 09h
	int		21h
	ret
Unlink	endp

IDsearch	proc	near
	$McbSer <offset ID>
	ret
IDsearch	endp


if $$PC9801
;------------------------------------------------;
; << get jis code's bit pattarn >> (NECPC9801XX) ;
; in  AX ...... jis code.                        ;
;     ds:bx ... db 32+2 dup(0) bit pattarn buf.  ;
; out ds:bx ... db bit pattarn.                  ;
;------------------------------------------------;
GetCharBit	proc near
	$push	<si,cx,bx,ax>
	mov		si, bx
	call	VsyncCheck			; vsync check.
	sub		ax, 2000h			;
	out		0a1h, al			;
	mov		al, ah				; set JIS code.
	out		0a3h, al			;
	mov		cx, 16				; loop 16 (2*16->32byte)
	xor		bl, bl
GetCharBit1:
	or		bl, 00100000b		;
	mov		al, bl				;
	out		0a5h, al			; get left 8bit pattarn.
	in		al, 0a9h			;
	mov		[si], al			;
	inc		si
	and		bl, 11011111b		;
	mov		al, bl				;
	out		0a5h, al			; get right 8bit pattarn.
	in		al, 0a9h			;
	mov		[si], al			;
	inc		si
	inc		bl
	loop	GetCharBit1
	$pop	<ax,bx,cx,si>
	ret
GetCharBit	endp
endif
if $$PANACOM
;------------------------------------------------;
; << get jis code's bit pattarn >>   (Panacom)   ;
; in  AX ...... jis code.                        ;
;     ds:bx ... db 32+2 dup(0) bit pattarn buf.  ;
; out ds:bx ... db bit pattarn.                  ;
;------------------------------------------------;
GetCharBit	proc near
	$push	<di,dx,bx,ax>
	mov		di, bx
	mov		bx, ax
	xchg	bh, bl
	mov		dh, 16
	mov		dl, 16
	mov		ah, 07h
	int		91h
	$pop	<ax,bx,dx,di>
	ret 
GetCharBit	endp
endif



KeepFont	proc	near
	push	ds
	$mov	ds, cs
	mov		ax, [JIS+0]
	lea		bx, [OrgBuff+0]
	call	GetCharBit
	mov		ax, [JIS+2]
	lea		bx, [OrgBuff+32]
	call	GetCharBit
	mov		ax, [JIS+4]
	lea		bx, [OrgBuff+64]
	call	GetCharBit
	pop		ds
	ret
KeepFont	endp

StoreFont	proc	near
	push	ds
	$mov	ds, es
	mov		ax, [JIS+0]
	lea		bx, [OrgBuff+0]
	call	PutCharBit
	mov		ax, [JIS+2]
	lea		bx, [OrgBuff+32]
	call	PutCharBit
	mov		ax, [JIS+4]
	lea		bx, [OrgBuff+64]
	call	PutCharBit
	pop		ds
	ret
StoreFont	endp



Copyright	label	word

if $$PC9801
	db	13,10, 'TSR Character Clock version 0.01 for PC98 (::)'
endif
if $$PANACOM
	db	13,10, 'TSR Character Clock version 0.02 for Panacom/FMR (::)'
endif
	db	13,10, 'Copyright (C) Satisfaction 1990. all rights reserved.'
	db	13,10, '$'

Msg01	label	word
	db	13,10, 'removed TSR Character Clock'
	db	13,10, '$'
	db	'Author: Seiji Yasuda '

_CODE	ends
		end		start


