;*******************************************
;*	FM16- version DISP.ASM
;********************************************
	TITLE   disp.c
	NAME    disp

	.8087
_TEXT	SEGMENT  WORD PUBLIC 'CODE'
_TEXT	ENDS
_DATA	SEGMENT  WORD PUBLIC 'DATA'
_DATA	ENDS
CONST	SEGMENT  WORD PUBLIC 'CONST'
CONST	ENDS
_BSS	SEGMENT  WORD PUBLIC 'BSS'
_BSS	ENDS
DGROUP	GROUP	CONST, _BSS, _DATA
	ASSUME  CS: _TEXT, DS: DGROUP, SS: DGROUP

MAX_X	equ	80
MAX_Y	equ	22
OFF_Y	equ	2

EXTRN	_Cur_X:WORD
EXTRN	_Cur_Y:WORD

_TEXT	SEGMENT
	ASSUME	CS: _TEXT
;***********************************
;*    int sjistojis(int code)
;***********************************
	PUBLIC	_sjistojis
_sjistojis	PROC NEAR
	push	bp
	mov	bp,sp

	mov	ax,[bp+4]		; code
	shl	ah,1			; Shift Jis to Jis
	cmp	al,080h
	adc	ax,1f61h
	add	al,7fh
	jc	knf1
	add	al,0a2h
knf1:	and	ah,7fh			; StoJ end

	pop	bp
	ret	
_sjistojis	ENDP
;***********************************************
;*    void wrtstr(char *str,int x,int y,int cl)
;***********************************************
	PUBLIC	_wrtstr
_wrtstr	PROC NEAR
	push	bp
	mov	bp,sp
	push	si
	push	di
	push	bx
	push	es

	mov	si,[bp+4]		; str
	mov	ax,MAX_X*2
	mul	word ptr[bp+8]		; y * (MAX_X * 2)
	mov	di,word ptr[bp+6]
	shl	di,1			; x * 2
	add	di,ax
	mov	ax,0C800h		; Text Vram Segment
	mov	es,ax

	mov	bl,[bp+10]		; cl
	and	bl,07h
	test	byte ptr[bp+10],10h	; cl
	jz	wrtat1
	or	bl,08h			; revasu on
wrtat1:	test	byte ptr[bp+10],08h
	jnz	wrtat2
	or	bl,20h			; Intnsity on

wrtat2:	cmp	word ptr[bp+6],0	; x != 0 ?
	jz	wrtlop
	test	byte ptr es:[di-1],40h	; kanji ?
	jz	wrtlop
	and	byte ptr es:[di-1],3Fh

wrtlop:	lodsb				; *(str++)

	cmp	al,1Bh
	je	wrtlop

	cmp	al,0
	jne	wrtlp1

	pop	es
	pop	bx
	pop	di
	pop	si
	pop	bp
	ret

wrtlp1:	cmp	al,81h
	jb	notkan
	cmp	al,9Fh
	jbe	iskan1
	cmp	al,0E0h
	jb	notkan
	cmp	al,0FCh
	ja	notkan
iskan1:	mov	ah,byte ptr[si]
	cmp	ah,40h
	jb	notkan
	cmp	ah,7Eh
	jbe	iskan2
	cmp	ah,80h
	jb	notkan
	cmp	ah,0FCh
	ja	notkan
iskan2:	inc	si
	xchg	ah,al

	shl	ah,1			; Shift Jis to Jis
	cmp	al,080h
	adc	ax,1f61h
	add	al,7fh
	jc	sknf1
	add	al,0a2h
sknf1:	and	ah,7fh			; StoJ end

	mov	byte ptr es:[di+2000h],ah
	mov	byte ptr es:[di+2001h],al
	mov	byte ptr es:[di+2002h],21h
	mov	byte ptr es:[di+2003h],21h

	mov	al,0FFh
	stosb
	mov	al,bl
	or	al,40h
	stosb

	mov	al,0FFh
	stosb
	mov	al,bl
	or	al,80h
	stosb

	jmp	wrtlop

notkan:	
	mov	byte ptr es:[di+2000h],21h
	mov	byte ptr es:[di+2001h],21h
	stosb
	mov	al,bl
	stosb
	jmp	wrtlop

_wrtstr	ENDP

;******************************************
;*    void Dsp_vram(char *vp)
;******************************************
	PUBLIC	_Dsp_vram
_Dsp_vram	PROC NEAR
	push	bp
	mov	bp,sp
	push	si
	push	di
	push	cx
	push	bx
	push	es

	mov	ax,0C800h		; Text Vram Segment
	mov	es,ax
	mov	di,MAX_X*2*OFF_Y

	mov	si,[bp+4]		; vp
	mov	cx,MAX_X*MAX_Y

dsplop:	lodsw				; *(vp++)
	mov	bl,al
	and	bl,07h
	test	al,10h
	jz	dsplp0
	or	bl,08h
dsplp0:	test	al,08h
	jnz	dsplp1
	or	bl,20h

dsplp1:	test	al,40h
	jz	dspank
	test	byte ptr[si],80h
	jz	dspank

	mov	al,[si+1]
	mov	byte ptr es:[di+2000h],ah
	mov	byte ptr es:[di+2001h],al
	mov	byte ptr es:[di+2002h],21h
	mov	byte ptr es:[di+2003h],21h

	mov	al,0FFh
	stosb
	mov	al,bl
	or	al,40h
	stosb

	mov	al,0FFh
	stosb
	mov	al,bl
	or	al,80h
	stosb

	add	si,2
	dec	cx
	jz	dspend
	jmp	dspchk

dspank:	test	al,0C0h
	jz	dspak2
	mov	ah,0FEh			; Dmy Kanji

dspak2:	mov	byte ptr es:[di+2000h],21h
	mov	byte ptr es:[di+2001h],21h
	mov	al,ah
	stosb
	mov	al,bl
	stosb
dspchk:	loop	dsplop

dspend:	mov	dh,byte ptr _Cur_Y
	mov	dl,byte ptr _Cur_X
	add	dh,OFF_Y
	inc	dh
	inc	dl
	mov	ah,0Dh		; Set Curol Pos
	int	91h

	pop	es
	pop	bx
	pop	cx
	pop	di
	pop	si
	pop	bp
	ret
_Dsp_vram	ENDP

;***************************************
	PUBLIC	_Dsp_init
_Dsp_init	PROC NEAR
	ret	
_Dsp_init	ENDP

	PUBLIC	_Dsp_roll
_Dsp_roll	PROC NEAR
	push	bp
	mov	bp,sp
	push	WORD PTR [bp+4]	;vp
	call	_Dsp_vram
	add	sp,2
	pop	bp
	ret	
	nop	
_Dsp_roll	ENDP

	PUBLIC	_Dsp_broll
_Dsp_broll	PROC NEAR
	push	bp
	mov	bp,sp
	push	WORD PTR [bp+4]	;vp
	call	_Dsp_vram
	add	sp,2
	pop	bp
	ret	
	nop	
_Dsp_broll	ENDP

	PUBLIC	_Dsp_vram_flash
_Dsp_vram_flash	PROC NEAR
	ret	
_Dsp_vram_flash	ENDP

;***************************************
;*    void colset(int *vp,int ch,int n);
;***************************************
	PUBLIC	_colset
_colset	PROC NEAR
	push	bp
	mov	bp,sp
	push	di
	push	cx
	push	es

	mov	ax,ds
	mov	es,ax

	mov	di,[bp+4]
	mov	ax,[bp+6]
	mov	cx,[bp+8]

	shr	cx,1		; n / 2
	cmp	cx,0
	jz	noncol

	rep stosw

noncol:	pop	es
	pop	cx
	pop	di
	pop	bp
	ret

_colset	ENDP

_TEXT	ENDS

END
