#include        <dos.h>

/************************************************/
/* RSB_PARA(8)                                  */
/************************************************/
typedef struct _RSB_PARA {
	unsigned char	mode;		/*  ʐM[h		 */
	unsigned char	baud;		/*  {[[g@	 */
	char far	*rbuf;		/*  Mobt@AhX */
	unsigned 	stime;		/*@M^CAEg	 */
  	unsigned 	rtime;		/*@M^CAEg	 */
	char far	*rinfbuf;	/*  MʒmAhX	 */
	unsigned char	extmode;	/*  g[h		 */
	unsigned char   xon;            /*  XONR[h            */
	unsigned char	xoff;		/*  XOFFR[h		 */
} RSB_PARA;

/************************************************/
/* RSB_INT(9)					*/
/************************************************/
typedef struct _RSB_INT {
	unsigned char   flg;            /*  荞݃tO@        */
	long            cs_adr;         /*  CSM荞݃AhX */
	long            ci_adr;         /*  CIM荞݃AhX */
} RSB_INT;

/* VA|[ǧo */
int 	RSB_chk()
{
    union REGS regs;

    regs.h.ah = 0x00;
    int86(0x9B,&regs,&regs);
    return (regs.x.ax & 0xFF);
}

/* I[v */
int 	RSB_open(port)
int	port;
{
    union REGS regs;

    regs.h.ah = 0x01;
    regs.h.al = port;
    int86(0x9B,&regs,&regs);
    return (regs.h.ah);
}

/* N[Y */
int 	RSB_close(port)
int	port;
{
    union REGS regs;

    regs.h.ah = 0x02;
    regs.h.al = port;
    int86(0x9B,&regs,&regs);
    return (regs.h.ah);
}

/* ʐMp[^̐ݒ */
int     RSB_setpara(port,paraadr)
int     port;
RSB_PARA *paraadr;
{
    char far *p;
    union REGS regs;
    struct SREGS sregs;

    regs.h.ah = 0x03;
    regs.h.al = port;
    p = (char *)paraadr;
    regs.x.di = FP_OFF(p);
    sregs.ds = FP_SEG(p);
    int86x(0x9B,&regs,&regs,&sregs);
    return (regs.h.ah);
}

/* ʐMp[^̓ǂݎ */
int     RSB_rdpara(port,paraadr)
int     port;
RSB_PARA *paraadr;
{
    char far *p;
    union REGS regs;
    struct SREGS sregs;

    regs.h.ah = 0x04;
    regs.h.al = port;
    p = (char *)paraadr;
    regs.x.di = FP_OFF(p);
    sregs.ds = FP_SEG(p);
    int86x(0x9B,&regs,&regs,&sregs);
    return (regs.h.ah);
}

/* Mobt@̗Lf[^̓ǂݎ */
int     RSB_read(port,leng)
int     port;
int     *leng;
{
    union REGS regs;

    regs.h.ah = 0x05;
    regs.h.al = port;
    int86(0x9B,&regs,&regs);
    *leng = regs.x.dx;
    return (regs.h.ah);
}

/* f[^̎M */
int 	RSB_receive(port,data,status)
int     port;
int     *data;
unsigned int *status;
{
    union REGS regs;

    regs.h.ah = 0x06;
    regs.h.al = port;
    int86(0x9B,&regs,&regs);
    *data = regs.h.dl;
    *status = regs.h.dh;
    return (regs.h.ah);
}

/* f[^̑M */
int     RSB_send(port,data,status)
int     port;
unsigned int *status;
{
    union REGS regs;

    regs.h.ah = 0x07;
    regs.h.al = port;
    regs.h.dl = data;
    int86(0x9B,&regs,&regs);
    *status = regs.h.dh;
    return (regs.h.ah);
}

/* VA|[g̐ */
int     RSB_ctrl(port,ctrl)
int     port;
unsigned int ctrl;
{
    union REGS regs;

    regs.h.ah = 0x08;
    regs.h.al = port;
    regs.h.dl = ctrl;
    int86(0x9B,&regs,&regs);
    return (regs.h.ah);
}

/* Xe[^X̓ǂݎ */
int     RSB_status(port,status,serial)
int     port;
unsigned int *status,*serial;
{
    union REGS regs;

    regs.h.ah = 0x09;
    regs.h.al = port;
    int86(0x9B,&regs,&regs);
    *status = regs.x.bx;
    *serial = regs.x.dx;
    return (regs.h.ah);
}

/* Mobt@̏ */
int     RSB_initbuf(port)
int     port;
{
    union REGS regs;

    regs.h.ah = 0x0A;
    regs.h.al = port;
    int86(0x9B,&regs,&regs);
    return (regs.h.ah);
}

/* u[NM̑M */
int     RSB_break(port,breaktime)
int     port;
unsigned int breaktime;
{
    union REGS regs;

    regs.h.ah = 0x0B;
    regs.h.al = port;
    regs.x.dx = breaktime;
    int86(0x9B,&regs,&regs);
    return (regs.h.ah);
}

/* g荞݂̐ݒ */
int     RSB_setint(port,intbuf)
int     port;
char    *intbuf;
{
    char far *p;
    union REGS regs;
    struct SREGS sregs;

    regs.h.ah = 0x0C;
    regs.h.al = port;
    p = intbuf;
    regs.x.di = FP_OFF(p);
    sregs.ds = FP_SEG(p);
    int86x(0x9B,&regs,&regs,&sregs);
    return (regs.h.ah);
}

/* g荞݂̓ǂݎ */
int     RSB_rdint(port,intbuf)
int     port;
char    *intbuf;
{
    char far *p;
    union REGS regs;
    struct SREGS sregs;

    regs.h.ah = 0x0D;
    regs.h.al = port;
    p = intbuf;
    regs.x.di = FP_OFF(p);
    sregs.ds = FP_SEG(p);
    int86x(0x9B,&regs,&regs,&sregs);
    return (regs.h.ah);
}

/* gcsqM̕ێݒ */
int     RSB_dtr(port,sw)
int     port;
int     sw;
{
    union REGS regs;

    regs.h.ah = 0x0E;
    regs.h.al = port;
    regs.h.dl = sw;
    int86(0x9B,&regs,&regs);
    return (regs.h.ah);
}

/* eXg[h̐ݒ */
int 	RSB_testmode(port,ctrl)
int	port;
unsigned int ctrl;
{
    union REGS regs;

    regs.h.ah = 0xFD;
    regs.h.al = port;
    regs.h.dl = ctrl;
    int86(0x9B,&regs,&regs);
    return (regs.h.ah);
}

/* v^Ԃ̓ǂݎ */
int	PRB_status(status)
unsigned int *status;
{
    union REGS regs;

    regs.x.ax = 0x0000;
    int86(0x94,&regs,&regs);
    *status = regs.x.dx;
    return (regs.h.ah);
}
/* 1o */
int	PRB_chr(ch)
char	ch;
{
    union REGS regs;

    regs.x.ax = 0x0100;
    regs.h.dl = ch;
    int86(0x94,&regs,&regs);
    return (regs.h.ah);
}
