/*
    Wind Consol
*/
#include    <stdio.h>
#include    <stdlib.h>
#include    <string.h>
#include    <ctype.h>
#include    <jctype.h>
#include    "defs.h"

int     read_line(p,fp)
register char p[];
FILE    *fp;
{
    int     i,n,ch;

    if ( feof(fp) )
        return ERR;

    i = 0;
    while ( i < 80 && (ch = getc(fp)) != EOF ) {
RETRY:
        if ( ch == '\n' ) {
            p[i++] = '\n';
            break;

        } else if ( ch == '\t' ) {
            n = TAB - (i % TAB);
            if ( n-- > 0 && i < 80 )
                p[i++] = '\t';
            while ( n-- > 0 && i < 80 )
                p[i++] = ' ';

        } else if ( iskanji(ch) ) {
            if ( i >= (80 - 1) ) {
                ungetc(ch,fp);
                break;
            }
            if ( (n = getc(fp)) == EOF )
                break;

            if ( !iskanji2(n) ) {
                ch = n;
                goto RETRY;
            }
            p[i++] = ch;
            p[i++] = n;

        } else if ( ch >= ' ' )
            p[i++] = ch;
    }
    p[i] = '\0';

    return FALSE;
}
void    get_file(no,lp)
int     no;
LIN_PTR *lp;
{
    int     i,n,o;
    WIN_PTR *cp;
    LIN_PTR *tp;

    cp = &(wind[no]);
    o = (lp == NULL ? ERR:lp->bp_no);

    for ( i = 0 ; i < 2 ; i++ ) {
        n = xalloc();
        tp = get_lin(n);
	tp->new_flg = TRUE;
        if ( read_line(tp->lin,cp->fp) ) {
            xfree(n);
            fclose(cp->fp);
            cp->fp = NULL;
            break;
        }
        tp->right = o;
        tp->left = ERR;
        if ( o != ERR ) {
            lp = get_lin(o);
            lp->left = n;
        } else
            cp->now_ptr = n;
        o = n;
        cp->lin_max++;
    }
}
void    WIN_open(no,file)
int     no;
char    *file;
{
    if ( (wind[no].fp = fopen(file,"r")) != NULL )
        get_file(no,NULL);
    wind[no].file = strdup(file);
    wind[no].wrt_mode = 3;
}
int     read_file(no,file)
int     no;
char    *file;
{
    int     i,n,o,s;
    FILE    *fp;
    WIN_PTR *cp;
    LIN_PTR *lp;
    LIN_PTR *tp;

    if ( (fp = fopen(file,"r")) == NULL )
        return ERR;

    cp = &(wind[no]);
    if ( (o = cp->now_ptr) != ERR ) {
        lp = get_lin(o);
        s = lp->right;
    } else
        s = ERR;

    for ( i = 0 ; ; i++ ) {
        n = xalloc();
        tp = get_lin(n);
	tp->new_flg = TRUE;
        if ( read_line(tp->lin,fp) ) {
            xfree(n);
            break;
        }
        if ( tp->lin[0] == '\0' && o != ERR )
            break;
        tp->right = s;
        tp->left = o;
        if ( s != ERR ) {
            lp = get_lin(s);
            lp->left = n;
        }
        if ( o != ERR ) {
            lp = get_lin(o);
            lp->right = n;
        } else
            cp->now_ptr = n;

        s = n;
        cp->lin_pos++;
        cp->lin_max++;
    }

    if ( i >= cp->max_y )
        cp->cur_y = cp->max_y / 2;
    else if ( cp->cur_y < i )
        cp->cur_y = i;

    cp->wrt_mode = 3;
    cp->wrt_flg = TRUE;

    fclose(fp);
    return FALSE;
}
void    write_line(str,fp)
char    *str;
FILE    *fp;
{
    int     n,i,j;

    for ( n = 0 ; *str != '\0' ; ) {
        if ( *str == '\t' ) {
            i = TAB - n % TAB;
            for ( j = 1 ; j < i ; j++ ) {
                if ( str[j] != ' ' )
                    break;
            }
            if ( j == i ) {
                putc(*str,fp);
                str += i;
                n += i;
            } else {
                putc(' ',fp);
                str++;
                n++;
            }
        } else {
            putc(*(str++),fp);
            n++;
        }
    }
}
void	Make_Tmp(file,sub)
char	*file;
char	*sub;
{
    char   *p;

    if ( (p = strrchr(file,'\\')) == NULL )
	p = file;
    if ( (p = strrchr(p,'.')) == NULL )
	for ( p = file ; *p != '\0' ; p++ );
    strcpy(p,sub);
}
int     put_file(no)
int     no;
{
    int     ch,n;
    FILE    *fp;
    WIN_PTR *cp;
    LIN_PTR *lp;
    long    l,ftell();
    char    wrk[128];
    char    bak[128];

    cp = &(wind[no]);

    if ( cp->wrt_flg == FALSE )
        return FALSE;

    strcpy(wrk,cp->file); Make_Tmp(wrk,".$8$");
    strcpy(bak,cp->file); Make_Tmp(bak,".bak");

    if ( (fp = fopen(wrk,"w")) == NULL )
        return ERR;

    if ( (n = cp->now_ptr) != ERR ) {
        for ( ; ; ) {
            lp = get_lin(n);
            if ( lp->right == ERR )
                break;
            n = lp->right;
        }
    }

    while ( n != ERR ) {
        lp = get_lin(n);
        write_line(lp->lin,fp);
        n = lp->left;
    }

    if ( ferror(fp) ) {
        fclose(fp);
        return ERR;
    }

    if ( cp->fp != NULL ) {
        l = ftell(cp->fp);

        while ( (ch = getc(cp->fp)) != EOF )
            putc(ch,fp);

        if ( ferror(cp->fp) || ferror(fp) ) {
            fseek(cp->fp,l,0);
            fclose(fp);
            return ERR;
        }

        fclose(cp->fp);
        cp->fp = NULL;
    }

    fclose(fp);

    unlink(bak);
    rename(cp->file,bak);
    rename(wrk,cp->file);

    cp->wrt_flg = FALSE;
    return FALSE;
}
