#include    <stdio.h>
#include    <stdlib.h>
#include    <string.h>
#include    <ctype.h>
#include    <jctype.h>
#include    "defs.h"

#define MAX_HIS 4
#define MAX_LIN max_len

static struct _LB {
    int     len;
    int     pos;
    char    buf[82];
} con_buf[MAX_HIS];

static  int     max_len=80;
static  int     con_his=0;
static  int     con_kan=0;

void    repchr(ch,n)
int     ch,n;
{
    while ( n-- > 0 )
        putch(ch);
}
char    *CON_input(ch)
int     ch;
{
    int     i,n;
    char    *p;
    struct _LB *lp;

    lp = &(con_buf[con_his]);
    lp->buf[lp->len] = '\0';

    if ( con_kan != 0 ) {
        if ( iskanji2(ch) )
            ch = (con_kan << 8) | ch;
        con_kan = 0;
    }

    if ( ch == '\x08' && lp->pos > 0 ) {
        lp->pos = kan_pos(lp->buf,lp->pos-1);
        p = &(lp->buf[lp->pos]);
        n = (iskan(p) ? 2:1);
        strcpy(p,p+n);
        lp->len -= n;

        repchr('\b',n);
        cprintf("%s  ",p);
        repchr('\b',lp->len - lp->pos + 2);

    } else if ( ch == 0x7F ) {
        if ( lp->pos < lp->len ) {
            p = &(lp->buf[lp->pos]);
            n = (iskan(p) ? 2:1);
            strcpy(p,p+n);
            lp->len -= n;

            cprintf("%s  ",p);
            repchr('\b',lp->len - lp->pos + 2);
        }

    } else if ( ch == 0x1C ) {
        if ( lp->pos < lp->len ) {
            n = (iskan(&(lp->buf[lp->pos])) ? 2:1);
            p = &(lp->buf[lp->pos]);
            lp->pos += n;
            while ( n-- > 0 )
                putchar(*(p++));
        }

    } else if ( ch == 0x1D ) {
        if ( lp->pos > 0 ) {
            lp->pos = kan_pos(lp->buf,lp->pos-1);
            p = &(lp->buf[lp->pos]);
            n = (iskan(p) ? 2:1);
            repchr('\b',n);
        }

    } else if ( ch == 0x1E ) {
        repchr('\b',lp->pos);
        repchr(' ',lp->len);
        repchr('\b',lp->len);

        if ( --con_his < 0 )
            con_his = (MAX_HIS - 1);

        lp = &(con_buf[con_his]);
        cprintf("%s",lp->buf);
        repchr('\b',lp->len - lp->pos);

    } else if ( ch == 0x1F ) {
        repchr('\b',lp->pos);
        repchr(' ',lp->len);
        repchr('\b',lp->len);

        if ( ++con_his >= MAX_HIS )
            con_his = 0;

        lp = &(con_buf[con_his]);
        cprintf("%s",lp->buf);
        repchr('\b',lp->len - lp->pos);

    } else if ( ch == 0x0D ) {
        p = lp->buf;
        if ( ++con_his >= MAX_HIS )
            con_his = 0;
        lp = &(con_buf[con_his]);
        lp->pos = lp->len = 0;
        lp->buf[0] = '\0';
        return p;

    } else if ( ch == 0x1B ) {
        repchr('\b',lp->pos);
        repchr(' ',lp->len);
        repchr('\b',lp->len);
        lp->pos = lp->len = 0;
        lp->buf[0] = '\x1B';
        return lp->buf;

    } else if ( ch >= ' ' && lp->len < MAX_LIN ) {
        n = ((ch & 0xFF00) != 0 ? 2:1);
        if ( n == 1 && iskanji(ch) ) {
            con_kan = ch;
            return FALSE;
        }
        if ( lp->pos < lp->len ) {
            p = &(lp->buf[lp->len + (n - 1)]);
            for ( i = lp->len - lp->pos ; i > 0 ; i--,p-- )
                *p = *(p - n);
        }
        i = lp->len - lp->pos;
        p = &(lp->buf[lp->pos]);
        if ( n == 1 ) {
            lp->buf[lp->pos++] = ch;
        } else {
            lp->buf[lp->pos++] = ch >> 8;
            lp->buf[lp->pos++] = ch;
        }
        lp->len += n;
        lp->buf[lp->len] = '\0';
        cprintf("%s",p);
        repchr('\b',i);
    }

    return NULL;
}
char    *input(ttl,str)
char    *ttl;
char    *str;
{
    char    *p;
    struct _LB *lp;

    if ( ttl != NULL ) {
        cprintf("\x0B\x1E%s",ttl);
        max_len = 77 - strlen(ttl);
    } else
        max_len = 77;

    if ( str != NULL ) {
        lp = &(con_buf[con_his]);
        strcpy(lp->buf,str);
        lp->pos = lp->len = strlen(str);
        cprintf("%s",str);
    }

    cursol(1);
    while ( (p = CON_input(getch())) == NULL );
    cursol(0);

    cprintf("\x0B\x1E\033[0K");

    if ( *p == '\x1B' )
        return NULL;
    else
        return p;
}
