/*
 *	display.h
 */
#ifndef	_DISPLAY_H
#define	_DISPLAY_H


/*	y[Wԍ̒`	*/
#define		Page0	0
#define		Page1	1
#define		Page2	2
#define		Page3	3


/*	\sNZ̒`	*/
#define		Mode3VirScrnX	1024
#define		Mode3VirScrnY	512
#define		Mode3RealScrnX	640
#define		Mode3RealScrnY	480

#define		Mode10VirScrnX	512
#define		Mode10VirScrnY	256
#define		Mode10RealScrnX	320
#define		Mode10RealScrnY	240

#define		Mode12VirScrnX	1024
#define		Mode12VirScrnY	512
#define		Mode12RealScrnX	640
#define		Mode12RealScrnY	480

#define		Mode17VirScrnX	512
#define		Mode17VirScrnY	512
#define		Mode17RealScrnX	512
#define		Mode17RealScrnY	480


/*	J[e[u̒`	*/
#define		ClutEntries	256

typedef	struct	{
	unsigned long	cnt;
	struct	clutEntry	{
		unsigned long	ci;
		unsigned char	blue;
		unsigned char	red;
		unsigned char	green;
		unsigned char	rsv;
	}	clutEntry[ClutEntries];
}	clutDataBlock_t;


/*	J[pbg錾		*/
extern	int	_DISP_palette[];

/*	J[obgݒ萔		*/
#define		DISP_PalReset		0
#define		DISP_PalColor32k	1
#define		DISP_PalColor256	2
#define		DISP_PalColor16		3

/*	J[pbgp Color Index	*/
#define		CI_Black		(_DISP_palette[0])
#define		CI_DarkBlue		(_DISP_palette[1])
#define		CI_DarkRed		(_DISP_palette[2])
#define		CI_DarkMagenta		(_DISP_palette[3])
#define		CI_DarkGreen		(_DISP_palette[4])
#define		CI_DarkCyan		(_DISP_palette[5])
#define		CI_DarkYellow		(_DISP_palette[6])
#define		CI_Gray			(_DISP_palette[7])
#define		CI_DarkGray		(_DISP_palette[8])
#define		CI_Blue			(_DISP_palette[9])
#define		CI_Red			(_DISP_palette[10])
#define		CI_Magenta		(_DISP_palette[11])
#define		CI_Green		(_DISP_palette[12])
#define		CI_Cyan			(_DISP_palette[13])
#define		CI_Yellow		(_DISP_palette[14])
#define		CI_White		(_DISP_palette[15])


/*	ʐFlFlւ̕ϊ	*/
#define		IGRB(i,g,r,b)	(((i & 0xff) << 24) | \
					((g & 0xff) << 16) | \
					((r & 0xff) << 8) | \
					(b & 0xff))

/*	ʐFlFԍւ̕ϊ	*/
#define		IGRB2(i,g,r,b)	(((i) ? 0x8000 : 0) | \
					((g & 0x1f) << 10) | \
					((r & 0x1f) << 5) | \
					(b & 0x1f))


extern	void
DISP_init(void);
/*
 *	PURPOSE
 *		ʂƃ}EX̏sD
 *			y[W0 : 320~240 32KF 2{g
 *			y[W1 : 640~480 16F
 *		y[W1OʂɂāCy[W\D
 *		̏݃y[W̓y[W1ƂȂD
 *		}EX̕\y[W̓y[W1ƂȂD
 */
extern	void
DISP_terminate(
	int	consoleMode);	/* R\[ʃ[hݒtO */
/*
 *	PURPOSE
 *		ʂ̕\IsD
 *		consoleMode0ȊOł΁C
 *		R\[ʃ[h(640~400 16F)ɐݒ肷D
 *		consoleMode0ł΁Cʃ[h͕ύXȂD
 */
extern	void
DISP_setScrnMode(
	int	page,		/* ݒΏۃy[W */
	int	mode);		/* ʃ[hԍ */
/*
 *	PURPOSE
 *		ʃ[hݒ肷D
 */
extern	long
DISP_getScrnMode(void);
/*
 *	PURPOSE
 *		ݐݒ肳Ăʃ[hʒmD
 *	RETURNS
 *		bit31...bit24	: y[W3
 *		bit23...bit16	: y[W2
 *		bit15...bit8	: y[W1
 *		bit7 ...bit0	: y[W0
 *		y[W01ʃ[h̏ꍇCy[W1`y[W3͖D
 */
extern	void
DISP_clearScreen(
	int	colorIGRB);	/* ʂF(IGRBl) */
/*
 *	PURPOSE
 *		\ʂw肳ꂽFŏD
 */
extern	void
DISP_setClut(
	char	*clutData);	/* EGB_palette()̑Rw */
/*
 *	PURPOSE
 *		ݑIĂy[W̃n[hEFAJ[LUT
 *		VSYNC҂ĕύXD
 */
extern	void
DISP_setClutNoiseless(
	char	*clutData);	/* EGB_palette()̑Rw */
/*
 *	PURPOSE
 *		ݑIĂy[W̃n[hEFAJ[LUTύXD
 *		xɐݒ肷Gg̍ő吔I48ƂĂ邽߁C
 *		̃Gg̐ݒ肪w肳ꂽꍇłʂɃmCYoȂD
 */
extern	void
DISP_getClut(
	int	top,		/* ʒm擪Ggԍ */
	int	entries,	/* ʒmGg */
	char	*clutData);	/* ʒm̈ւ̃|C^ */
/*
 *	PURPOSE
 *		݂̃J[e[ûCtopentries
 *		clutDataŎw肳ꂽ̈֒ʒmD
 */
extern	void
DISP_initClut16(void);
/*
 *	PURPOSE
 *		݂̏݃y[W̃n[hEFA16FJ[LUTD
 */
extern	void
DISP_initClut256(void);
/*
 *	PURPOSE
 *		݂̏݃y[W̃n[hEFA256FJ[LUTD
 */
extern	void
DISP_initClut256Noiseless(void);
/*
 *	PURPOSE
 *		݂̏݃y[W̃n[hEFA256FJ[LUTD
 *		LUT̕ύX͉ʂɃmCYoȂ@ōsD
 */
extern	void
DISP_setPalette(
	int	type);		/* 0:11, 1:32KF, 2:256F, 3:16F */
/*
 *	PURPOSE
 *		\tgEFApbgw肳ꂽԂɕύXD
 *		J[LUTԂł΁CCI_xxxxɂwFD
 */
extern	void
DISP_getPixelBlock(
	int		luX,
	int		luY,
	int		rdX,
	int		rdY,
	char		*buffer);	/* \Ώۃf[^ */
/*
 *	PURPOSE
 *		W(x1,y1)(x2,y2)܂ł̃sNZf[^
 *		buffer֎oD
 */
extern	void
DISP_putPixelBlock(
	int		luX,
	int		luY,
	int		rdX,
	int		rdY,
	char		*buffer);	/* \Ώۃf[^ */
/*
 *	PURPOSE
 *		buffer̃sNZf[^
 *		W(x1,y1)(x2,y2)܂łɕ\D
 */
extern	void
DISP_putBlock(
	int	luX,
	int	luY,
	int	rdX,
	int	rdY,
	char	*buffer,
	int	colorIx);
/*
 *	PURPOSE
 *		1rbg^sNZ̃mNf[^wFŕ\D
 */
extern	void
DISP_line(
	int	x1,			/* Jn_ */
	int	y1,
	int	x2,			/* I_ */
	int	y2,
	int	colorIndex);
/*
 *	PURPOSE
 *		wW1{̐`D
 */
extern	void
DISP_xorLine(
	int	x1,			/* Jn_ */
	int	y1,
	int	x2,			/* I_ */
	int	y2,
	int	colorIndex);
/*
 *	PURPOSE
 *		wWԐXOR[hŕ`D
 */
extern	void
DISP_rectangle(
	int	luX,
	int	luY,
	int	rdX,
	int	rdY,
	int	colorIndex);
/*
 *	PURPOSE
 *		w肵ʒuɎwF̖ʓh蒷`\D
 */
extern	void
DISP_xorRectangle(
	int	luX,
	int	luY,
	int	rdX,
	int	rdY,
	int	colorIndex);
/*
 *	PURPOSE
 *		w肵ʒuɎwF̖ʓh蒷`XOR[hŕ\D
 */
extern	void
DISP_rectBox(
	int	luX,
	int	luY,
	int	rdX,
	int	rdY,
	int	colorIndex);
/*
 *	PURPOSE
 *		w肵ʒuɎwF̒`̘g\D
 */
extern	void
DISP_xorRectBox(
	int	luX,
	int	luY,
	int	rdX,
	int	rdY,
	int	colorIndex);
/*
 *	PURPOSE
 *		w肵ʒuɎwF̒`̘gXOR[hŕ\D
 */
extern	void
DISP_stringAt(
	char	*string,
	int	x,
	int	y,
	int	colorIndex);
/*
 *	PURPOSE
 *		w肵ʒuɎwF̕\D
 */
extern	void
DISP_stringRect(
	char	*string,
	int	foreColor,		/* Ƙg̐F */
	int	backColor);		/* ̔wiF */
/*
 *	PURPOSE
 *		o͗̈C
 *		w肵640~480hbg̉ʒɕ\
 *		́Cw肵F̘gň͂ށD
 */
extern	void
DISP_setPage(
	int	page);
/*
 *	PURPOSE
 *		݃y[Wݒ肷D
 */
extern	int
DISP_getPixel(
	int	x,
	int	y);
/*
 *	PURPOSE
 *		w_̃sNZlIGRB`ŒʒmD
 *	RETURNS
 *		IGRB`̃sNZl
 */
extern	void
DISP_setPixel(
	int	x,
	int	y,
	int	colorIGRB);
/*
 *	PURPOSE
 *		IGRB`̃sNZlw_ɐݒ肷D
 */


#endif
/*****	display.h  *****/
