#include <stdio.h>
#include <string.h>

int  note_dx[] = { 470,520,530,590,600,620,680,730,750,780,860,890 };
char note_tbl[] = "C D EF G A B";
char tmp[1024];

int     eval(char *str, char *ptn)
{
    while ( *ptn != '\0' ) {
	if ( toupper(*str) != *ptn )
	    return 0;
	str++;
	ptn++;
    }
    return 1;
}

int	instr( int p, char *str, char *ptn )
{
	while( str[p] != '\0' ){
		if( eval( &str[p], ptn ) != 0)
			return p;
		p++;
	}
	return -1;
}

int get_number(int *pp, char *str )
{
int	n,sign,chr,p;

	sign = 1; n = 0; p = *pp;
	while( (chr = str[p]) == ' ' )
		p++;
	if ( chr == '+' ){
		sign =1;
		chr = str[++p];
	} else if ( chr == '-' ){
		sign =-1;
		chr = str[++p];
	}
	if( (chr<'0') || (chr>'9') )
		return -31000;
	while( (chr>='0') && (chr<='9') ){
		n = n*10 +(chr - '0');
		chr = str[++p];
	}
	*pp = p;
	return sign*n;
}


int chocking( int p, char *str )
{
int		st,flg,note,ofs,ofs1,base,l,i;
char	dmy[16],h[3],ad[2];

	st = p;
	p += 4;
	
	flg = str[p++];
	tmp[0] = str[p++]; tmp[1] ='\0'; h[0] = tmp[0];
	if( (note = instr(0, note_tbl, tmp)) < 0 )
		goto ERROR;
	tmp[0] = str[p]; tmp[1] ='\0'; h[1] = '\0';
	if( (i = instr(0, "#+-", tmp)) >= 0 ){
		if( i == 2 )
			note--;
		else
			note++;
		p++;
		h[1] = tmp[0];
		h[2] = '\0';
	}
	if( str[p++] != ',' )
		goto ERROR;
	ofs = get_number( &p, str );
	if( str[p++] != ',' )
		goto ERROR;
	l = get_number( &p, str );
	if( (ad[0] = str[p]) == '.' ){
		ad[1] = '\0';
		p++;
	}else
		ad[0] = '\0';
	
	base = 0;
	if( ofs >=0 )
		for( i=0 ; i<ofs ; i++ ){
			ofs1 = note + i;
			if( ofs1>11 )
				ofs1 -=12;
			base += note_dx[ofs1];
		}
	else
		for( i=-1 ; i>=ofs ; i-- ){
			ofs1 = note + i;
			if( ofs1 < 0)
				ofs1 +=12;
			base -= note_dx[ofs1];
		}
	sprintf(tmp,"L%-d%s",l*8,ad );
	if( toupper(flg) == 'U' )
		for( i=0 ; i<8 ; i++ ){
    		sprintf(dmy,"U%-d%s",base*i/7,h );
    		strcat(tmp,dmy);
    		if( i<7 )
    			strcat(tmp,"&");
    	}
    else if( toupper(flg) == 'D' )
		for( i=7 ; i>=0 ; i-- ){
    		sprintf(dmy,"U%-d%s",base*i/7,h );
    		strcat(tmp,dmy);
    		if( i>0 )
    			strcat(tmp,"&");
    	}
    else
		goto ERROR;

	strcat(tmp, &str[p]);
	strcpy(&str[st], tmp);

	return p;
ERROR:
	return -p;
}

int vibrate( int p, char *str )
{
int		st,note,depth,speed,base,l,sign,i;
char	dmy[16],h[3],ad[2];

	st = p;
	p += 4;
	
	tmp[0] = str[p++]; tmp[1] ='\0'; h[0] = tmp[0];
	if( (note = instr(0, note_tbl, tmp)) < 0 )
		goto ERROR;
	tmp[0] = str[p]; tmp[1] ='\0'; h[1] = '\0';
	if( (i = instr(0, "#+-", tmp)) >= 0 ){
		if( i == 2 )
			note--;
		else
			note++;
		p++;
		h[1] = tmp[0];
		h[2] = '\0';
	}
	if( str[p++] != ',' )
		goto ERROR;
	depth = get_number( &p, str );
	if( str[p++] != ',' )
		goto ERROR;
	speed = get_number( &p, str );
	speed *=2;
	if( str[p++] != ',' )
		goto ERROR;
	l = get_number( &p, str );
	if( (ad[0] = str[p]) == '.' ){
		ad[1] = '\0';
		p++;
	}else
		ad[0] = '\0';
	
	base = note_dx[note]/depth;
	sprintf(tmp,"L%-d%s",l*speed,ad );
	for( i=0 ; i<speed ; i++ ){
		if( ( i % 2 ) == 0 )
			sign = 1;
		else
			sign = -1;
   		sprintf(dmy,"U%-d%s",base*sign,h );
   		strcat(tmp,dmy);
   		if( i<speed-1 )
   			strcat(tmp,"&");
   	}

	strcat(tmp, &str[p]);
	strcpy(&str[st], tmp);

	return p;
ERROR:
	return -p;
}

int main( int argc, char *argv[] )
{
FILE *fp;

int	p,i,flg;
char buff[1024];

	flg = 0;
	if( (fp = fopen( argv[1], "rt" )) == NULL )
    	fp = stdin;

	while( fgets(buff,1024,fp) ){
		/* if( eval( buff, "*** EUP_DE_PON!" ) != 0 ) */
			flg = 1;
		/* else if( eval( buff, "*** END_OF_PON!" ) != 0 )
			flg = 0; */
		if( flg !=0 ){
			p = 0;
			while( (p = instr( p, buff, "CHO." )) >= 0)
				if( (p = chocking( p, buff )) < 0){
					fprintf( stderr,"JIMIHEN:Illegal param \n%s", buff );
					for(i =0 ; i<-p ; i++ )
						fprintf( stderr," ");
					fprintf( stderr,"^");
					return -1;
				}
			p = 0;
			while( (p = instr( p, buff, "VIB." )) >= 0)
				if( (p = vibrate( p, buff )) < 0){
					fprintf( stderr,"JIMIHEN:Illegal param \n%s", buff );
					for(i =0 ; i<-p ; i++ )
						fprintf( stderr," ");
					fprintf( stderr,"^");
					return -1;
				}
		}
		fputs(buff,stdout);
	}
	fclose(fp);
}
