/*
	program	fout.c

		usage : fout [<interval_time>]
*/


#include	<stdio.h>
#include	<stdlib.h>
#include	"stella.h"
#include	"ioport.h"

#define		crtc			0x0440
#define		dummyreg		    30
#define		video_out_ctrl	0x0448
#define		priority		  0x01

#define		alg_pal			0xfd90
#define		blue_pal		0xfd92
#define		red_pal			0xfd94
#define		green_pal		0xfd96

#define		division			16

typedef	struct{
			int		r,
					g,
					b;
}		rgbty;


extern	void
		setpal(
			rgbty	pal[]
		),
		readpal(
			rgbty	pal[]
		);


void
main(
	int		ac,
	char	**ag
){
	int		i,j,w,
			inter;
	rgbty	hpal[16],
			fpal[16];
	
	if(ac!=1){
		inter = atoi(ag[1]);
	}else{
		inter = 30000;
	}

	readpal(hpal);
	for(i=0;i<=division;++i){
		for(j=0;j<16;++j){
			fpal[j].r = (hpal[j].r*(division-i))/division;
			fpal[j].g = (hpal[j].g*(division-i))/division;
			fpal[j].b = (hpal[j].b*(division-i))/division;
		}
		setpal(fpal);
		for(w=0;w<inter;++w);
	}
}


void
setpal(
	rgbty	pal[]
){
	int		i;

	enable16c();
	outrb(video_out_ctrl,priority,1|0x08);
										/* layer 0,16c pal /  adv layer 1 */


	while((inrw(crtc,dummyreg)&0x0400)==0);
	for(i=0;i<16;++i){
		outpb(alg_pal	,i);
		outpb(blue_pal	,pal[i].b<<4);
		outpb(red_pal	,pal[i].r<<4);
		outpb(green_pal	,pal[i].g<<4);
	}
}


void
readpal(
	rgbty	pal[]
){
	int		i;
		
	outrb(video_out_ctrl,priority,1|0x08);
										/* layer 0,16c pal /  adv layer 1 */
	for(i=0;i<16;++i){
		outpb(alg_pal,i);
		pal[i].b = inpb(blue_pal )>>4;
		pal[i].r = inpb(red_pal	 )>>4;
		pal[i].g = inpb(green_pal)>>4;
	}
}


/*
	end of prog
*/
