/*
	program	GETPAL.C
		
		for FM-Towns
*/
#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	"stella.h"
#include	"ioport.h"

#define		video_out_ctrl		0x0448
#define		priority		0x01

#define		alg_pal			0xfd90
#define		blue_pal		0xfd92
#define		red_pal			0xfd94
#define		green_pal		0xfd96

typedef	struct{
			char		r0, r,
					g0, g,
					b0, b;
}		brgbty;

extern	void	getpal( char *fname );


void	main( int ac,  char *ag[] )
{
	char	fname[20];
	
	if (  0 != strlen ( ag[1] ) )
	  {
		strcpy ( fname, ag[1] );
		strcat ( fname, ".P0F" );
		getpal ( fname );
	  }
}

void	getpal( char *fname )
{
	FILE		*af;
	int		i;
	brgbty          bpal[16];


	enable16c();
	outregb(video_out_ctrl,priority,1|0x08);
	/* layer 0,16c pal /  adv layer 1 */


	for(i=0;i<16;++i)
	  {
		outpb(alg_pal	,i);
		bpal[i].b = (inpb( blue_pal )  >> 4) * 0x11;
		bpal[i].r = (inpb( red_pal )   >> 4) * 0x11;
		bpal[i].g = (inpb( green_pal ) >> 4) * 0x11;
		bpal[i].b0 = bpal[i].r0 = bpal[i].g0 = 0;
	  }

	af = fopen ( fname,"wb" );
	fwrite ( bpal,6,16,af);
	fclose ( af );
}


/*	end of prog      */
