/********************************************

@@PON`=>EUPRo[^u|Iłdtov
      Programmed by c`qj

     Ver0.01  1990/08/03	Make by YAMA
              1990/08/24	Remake by Ken

**********************************************/
#include <stdio.h>
#include <ctype.h>
#include <string.h>

#define	TRUE	1
#define	FALSE	0
#define	ERR	(-1)

#define UCHAR unsigned char
#define UINT  unsigned int
#define ULINT unsigned long int

#define MAX_BUFF_SIZE	(1024*256)
#define MAX_PART	14

extern void dsp_msg();

/*  data for EUP_CNV */

static int   hyousi = 0x33;
static int   tempo = 120;
static int   program = 14;

static int   str_cnt = 1;
static int   bar = 1;
static int   part = 0;
static int   part_assign[MAX_PART];
static int   step_time[MAX_PART];
static int   str_ptr[MAX_PART];
static int   max_step;
static int   chr;

static char  cmd1_tbl[] = "C D EF G A BR";
static char  cmd2_tbl[] = "O<>LV[]QT@U&!";

static int   v[MAX_PART];
static int   q[MAX_PART];
static int   l[MAX_PART];
static int   priod[MAX_PART];
static int   o[MAX_PART];
static int   tai[MAX_PART];
static int   va[MAX_PART];
static int   vt[MAX_PART];

static int   last_note[MAX_PART];
static ULINT last_buff_ptr[MAX_PART];
static int   last_clock[MAX_PART];

static ULINT buff_ptr;
static char  eup_buff[MAX_BUFF_SIZE];
static char  *mml[MAX_PART];

/* lower sub routines of EUPCNV */

static void ncnv1(int num, ULINT p )
{
    register char   *bp;

    bp = &eup_buff[p];
    *(bp++) = (num & 0x7F);
    *bp = ((num >> 7) & 0x7F);
}

static void ncnv2(int num, ULINT p)
{
    register char   *bp;

    num--;
    bp = &eup_buff[p];
    *(bp++) = (num & 0x0F); num >>= 4;
    *(bp++) = (num & 0x0F); num >>= 4;
    *(bp++) = (num & 0x0F); num >>= 4;
    *bp = (num & 0x0F);
}

static void ncnv3(ULINT num, ULINT p)
{
    *((ULINT *)(&eup_buff[p])) = num;
}

int	instr(char *str, int c )
{
    int    i;

    for ( i = 0 ; *str != '\0' ; i++ ) {
	if ( *(str++) == c )
	    return i;
    }
    return ERR;
}

static int	get_number()
{
    int     n,sign;

    sign = 1;

    while( (chr = mml[part][str_ptr[part]]) == ' ' || chr == '\t' )
	str_ptr[part]++;

    if ( chr == '+' ) {
	sign = 1;
	chr = mml[part][++str_ptr[part]];
    } else if ( chr == '-' ){
	sign = (-1);
	chr = mml[part][++str_ptr[part]];
    }

    if( !isdigit(chr) )
	return (-31000);

    n = 0;
    while( isdigit(chr) ){
	n = n * 10 + (chr - '0');
	chr = mml[part][++str_ptr[part]];
    }
    return (sign * n);
}

static void	gate_change( int gate_time )
{
    ncnv2(gate_time, last_buff_ptr[part]+1);
}

static void	note_off( int gate_time )
{
    eup_buff[buff_ptr] = (char)0x80;
    ncnv2(gate_time, buff_ptr+1);
    eup_buff[buff_ptr+5] = 0;
    buff_ptr += 6;
}

static void note_on( char track, int stp_tim, char note, char velo )
{
    eup_buff[buff_ptr] = (char)0x90;
    eup_buff[buff_ptr+1] = (char)part_assign[track];
    ncnv1(stp_tim, buff_ptr+2);
    eup_buff[buff_ptr+4] = note;
    eup_buff[buff_ptr+5] = velo;
    buff_ptr += 6;
}

static void controll_change( char track, int stp_tim, char cntrl, char value )
{
    eup_buff[buff_ptr] = (char)0xb0;
    eup_buff[buff_ptr+1] = (char)part_assign[track];
    ncnv1(stp_tim, buff_ptr+2);
    eup_buff[buff_ptr+4] = cntrl;
    eup_buff[buff_ptr+5] = value;
    buff_ptr += 6;
}

static void program_chang( char track, int stp_tim, char prog )
{
    eup_buff[buff_ptr] = (char)0xc0;
    eup_buff[buff_ptr+1] = (char)part_assign[track];
    ncnv1(stp_tim, buff_ptr+2);
    eup_buff[buff_ptr+4] = prog-1;
    eup_buff[buff_ptr+5] = 0xff;
    buff_ptr += 6;
}

static void pitch_bend( char track, int stp_tim, int bend )
{
    eup_buff[buff_ptr] = (char)0xe0;
    eup_buff[buff_ptr+1] = (char)part_assign[track];
    ncnv1(stp_tim, buff_ptr+2);
    ncnv1(bend+8192, buff_ptr+4);
    buff_ptr += 6;
}

static void bar_mark( int stp_tim )
{
    eup_buff[buff_ptr] = (char)0xf2;
    eup_buff[buff_ptr+1] = (char)hyousi;
    ncnv1(stp_tim, buff_ptr+2);
    eup_buff[buff_ptr+4] = 0xff;
    eup_buff[buff_ptr+5] = 0xff;
    buff_ptr += 6;
}

static void tempo_set( int stp_tim )
{
    eup_buff[buff_ptr] = (char)0xf8;
    eup_buff[buff_ptr+1] = 0xff;
    ncnv1(stp_tim, buff_ptr+2);
    ncnv1(tempo-30, buff_ptr+4);
    buff_ptr += 6;
}

static void end_mark( int stp_tim )
{
    eup_buff[buff_ptr] = (char)0xfe;
    eup_buff[buff_ptr+1] = (char)hyousi;
    ncnv1(stp_tim, buff_ptr+2);
    eup_buff[buff_ptr+4] = 0xff;
    eup_buff[buff_ptr+5] = 0xff;
    buff_ptr += 6;
}

/* middle sub routines of EUPCNV */

static void note (int cmd)
{
    int     stp_tim,clock,gate;
    int     note,vol;
    int     clock_w,priod_w,n;

    note = cmd;
    chr = mml[part][str_ptr[part]];

    if( chr != '\0' ){
	cmd = instr( "#+-", chr );
	if( cmd != ERR ) {
	    chr = mml[part][++str_ptr[part]];
	    if( cmd == 2 )
		note--;
	    else
		note++;
	}
    }

    n = get_number();
    if( n < 0 ) {
	clock_w = l[part];
	priod_w = priod[part];
    } else {
	clock_w = n;
	priod_w = 384;
    }

    chr = mml[part][str_ptr[part]];

    if( chr == '.' ){
	chr = mml[part][++str_ptr[part]];
	priod_w = 576;			/* 576 = 384*1.5 */
    }
    clock = priod_w / clock_w;
    gate = (clock * q[part]) / 8;

    if ( vt[part] != ERR ) {
	vol = vt[part] * 8 + 7;
	vt[part] = ERR;
    } else if ( va[part] != ERR )
	vol = va[part];
    else
	vol = v[part] * 8 + 7;

    stp_tim = step_time[part];

    if( note != 12 ){
	note = (o[part]+1) * 12 + note;
	if( tai[part] != FALSE && note == last_note[part] ){
	    gate += last_clock[part];
	    gate_change(gate);
	    last_clock[part] += clock;

	} else {
	    note_on( part, stp_tim, note, vol );
	    note_off(gate);
	    last_note[part] = note;
	    last_buff_ptr[part] = buff_ptr - 6;
	    last_clock[part] = clock;
	}
    }

    step_time[part] += clock;
    max_step = step_time[part];
    tai[part] = FALSE;
}

static int set_o()
{
    int  n;

    if ( (n = get_number()) < 1 || n > 8 )
	return ERR;

    o[part] = n;
    return FALSE;
}

static int down_o ()
{
    if ( --o[part] < 1 ) {
	o[part] = 1;
	return ERR;
    }

    return FALSE;
}

static int up_o ()
{
    if ( ++o[part] > 8 ) {
	o[part] = 8;
	return ERR;
    }

    return FALSE;
}

static int set_l()
{
    int     n;

    if ( (n = get_number()) < 0 )
	return ERR;

    l[part] = n;
    chr = mml[part][str_ptr[part]];

    if ( chr == '.' ) {
	chr = mml[part][++str_ptr[part]];
	priod[part] = 576;		/* 576 = 384*1.5 */
    } else
	priod[part] = 384;

    return FALSE;
}

static int set_v()
{
    int     n;

    va[part] = ERR;

    if ( (n = get_number()) < 0 || n > 15 )
	return ERR;

    v[part] = n;
    return FALSE;
}

static int down_v ()
{
    va[part] = ERR;

    if ( --v[part] < 0 )
	v[part]=0;

    return FALSE;
}

static int up_v ()
{
    va[part] = ERR;

    if ( ++v[part] > 15 )
	v[part]=15;

    return FALSE;
}

static int set_q()
{
    int     n;

    if ( (n = get_number()) < 0 || n > 10 )
	return ERR;

    q[part] = n;
    return FALSE;
}

static int set_t()
{
    int     n,sign;

    sign = 0;

    while( (chr = mml[part][str_ptr[part]]) == ' ' || chr == '\t' )
	str_ptr[part]++;

    if ( chr == '+' ){
	sign = 1;
	chr = mml[part][++str_ptr[part]];
    } else if ( chr == '-' ){
	sign = (-1);
	chr = mml[part][++str_ptr[part]];
    }

    if ( (n = get_number()) < 0 )
	return ERR;

    if( sign == 0 ) {
	if ( n < 30 || n > 280 )
	    return ERR;

	tempo = n;

    } else {
	if ( n < 0 || n > 15 )
	    return ERR;

	if ( sign == 1 )
	    tempo += n;
	else
	    tempo -= n;
    }

    tempo_set( step_time[part] );

    return FALSE;
}

static int set_program()
{
    int    n;

    chr = mml[part][str_ptr[part]];

    if ( chr == 'V' || chr == 'v' ) {
	chr = mml[part][++str_ptr[part]];
	if ( (n = get_number()) < 0 || n > 127 )
	    return ERR;

	va[part] = n;

    } else {
	if ( (n = get_number()) < 1 || n > 128 )
	    return ERR;

	program = n;
	program_chang( part, step_time[part], program );
    }

    return FALSE;
}

static int set_u()
{
    int     n;

    if ( (n = get_number()) < (-8192) || n > 8192 )
	return ERR;

    pitch_bend( part, step_time[part], n );
    return FALSE;
}

static int set_tai()
{
    gate_change( last_clock[part] );

    tai[part] = ERR;
    return FALSE;
}

static int set_accsent()
{
    int     n;

    if ( (n = get_number()) < 1 || n > 15 )
	vt[part] = 15;
    else
	vt[part] = n;

    return FALSE;
}

static int set_e_l()
{
    int     n, bak_p;

    bak_p = str_ptr[part];

    if ( (n = get_number()) < 1 || n > 15 ) {
	n = 15;
	str_ptr[part] = bak_p;
    }

    n = 60 - n * 4;
    controll_change( part, step_time[part], 0x0a, n );
    return FALSE;
}

static int set_e_r()
{
    int     n, bak_p;

    bak_p = str_ptr[part];

    if ( (n = get_number()) < 1 || n > 15 ) {
	n = 15;
	str_ptr[part] = bak_p;
    }

    n = 67 + n * 4;
    controll_change( part, step_time[part], 0x0a, n );
    return FALSE;
}

static int set_e_c()
{
    controll_change( part, step_time[part], 0x0a, 64 );
    return FALSE;
}

/* main routines of EUPCNV */

void EUP_open( char *title, char *filename, int pt_as[],
               char *fm_file, char *pcm_file )
{
    int     i;

    if( title    == NULL ) title = "";
    if( filename == NULL ) filename = "";
    if( fm_file  == NULL ) fm_file = "";
    if( pcm_file == NULL ) pcm_file = "";

/* Initialize values */

    hyousi = 0x33;
    tempo = 120;
    program = 14;

    for ( i = 0 ; i < MAX_PART ; i++ ) {
/****************************************
	part_assign[i] = pt_as[i];
*****************************************/
	part_assign[i] = i;

	v[i] = 8;
	q[i] = 8;
	l[i] = 4;
	priod[i] = 384;
	o[i] = 4;
	va[i] = ERR;
	vt[i] = ERR;
	tai[i] =FALSE;
	step_time[i] = 0;
    }

    str_cnt = 1;
    bar = 1;
    part = 0;

    buff_ptr = 0x806;

/* set header */

    memset(eup_buff,0,2048);

    strncpy(&eup_buff[0],title,32);
    strncpy(&eup_buff[0x20],filename,8);

    memset(&eup_buff[0x354],0xFF,32);
    memset(&eup_buff[0x374],0xFF,32);

    for ( i = 0 ; i < 32 ; i++ )
	eup_buff[0x394 + i] = i < 14 ? (i + 1):0x0F;

    memset(&eup_buff[0x3F4],0xFF,224);

    for ( i = 0 ; i < 14 ; i++ )
	eup_buff[0x6D4 + i] = (pt_as[i] + 1);

    strncpy(&eup_buff[0x6E2],fm_file,8);
    strncpy(&eup_buff[0x6EA],pcm_file,8);

    strncpy(&eup_buff[0x7F6],"EUP_PON",8);
    strncpy(&eup_buff[0x7FE],"01",2);

    eup_buff[0x804] = hyousi;
    eup_buff[0x805] = (tempo - 30 );

}


int    EUP_send( char *mp[] )
{
    static int (*jmp_tbl[])()={
	set_o, down_o, up_o, set_l, set_v, down_v, up_v , set_q,
	set_t, set_program, set_u, set_tai, set_accsent
    };
    static int (*e_jmp_tbl[])()={ set_e_l, set_e_r, set_e_c };

    char    flg[14];
    char  bar_end=0,str_end=0,end_flg=0;
    int   i;
    int   cmd;

    for( i = 0 ; i < MAX_PART ; i++ ){
	if ( (mml[i] = mp[i]) == NULL )
	    mml[i] = "\0";

	if ( mml[i][0] == 0 )
	    step_time[i] = 384;

	str_ptr[i] = 0;
    }

    while( (str_end & 2) == 0 ){
	for( i = 0 ; i < MAX_PART ; i++ ) {
	    flg[i] = 0;

	    if( mml[i][str_ptr[i]] == '\0' )
		flg[i] |= 2;

	    if( step_time[i] >= 384 )
		flg[i] |= 1;
	}

	part = 0;
	bar_end = 0;
	str_end = 0;
	end_flg = 0;

	while( end_flg == 0 ){

	    if ( buff_ptr >= (MAX_BUFF_SIZE - 1550) ) {
		dsp_msg("Buffer over flow Error\n");
		return ERR;
	    }

	    if( (flg[part] & 2) == 0){
		chr = mml[part][str_ptr[part]++];
		if( chr != ' ' && chr != '\t' ){
		    chr = toupper(chr);
		    if( (cmd = instr( cmd1_tbl, chr )) != -1 )
			note( cmd );

		    else if( (cmd = instr( cmd2_tbl, chr )) != -1 ){
			if( (*jmp_tbl[cmd])() != 0 )
			    goto ERROR;

		    } else if( chr == '%' ){
			chr = mml[part][str_ptr[part]++];
			if( (cmd = instr( "LRC", chr )) != -1 ) {
			    if( (*e_jmp_tbl[cmd])() != 0 )
				goto ERROR;
			}

		    } else
			goto ERROR;
		}
	    }

	    flg[part] = 0;

	    if( mml[part][str_ptr[part]] == 0 )
		flg[part] |= 2;

	    if( step_time[part] >= 384 )
		flg[part] |= 1;
				
	    bar_end = 0;
	    str_end = 3;
	    end_flg = 255;

	    for( i = 0 ; i < MAX_PART ; i++ ) {
		if ( (step_time[i] < step_time[part]) && ((flg[i] & 2)== 0) )
		    part = i;

		if ( ((flg[i] & 2)== 0) && ((flg[part] & 2)!= 0) )
		    part = i;

		bar_end |= flg[i];
		str_end &= flg[i];

		if( flg[i] == 0 )
		    end_flg = 0;
	    }
	}

	if ( (bar_end & 1) == 1 ){
	    bar_mark(384);
	    bar++;

	    for( i = 0 ; i < MAX_PART ; i++ ){
		step_time[i] -= 384;
		if( step_time[i] < 0 )
		    step_time[i] = 0;
	    }

	    max_step -= 384;
	    if( max_step < 0 )
		max_step = 0;
	}
    }

    for( i = 0 ; i < MAX_PART ; i++ )
	step_time[i] = max_step;

    str_cnt++;
    return FALSE;

ERROR:
    dsp_msg(" Sintax Error Abort\n");
    dsp_msg("%2d Part : %s\n",part,mml[part]);
    dsp_msg("          ");
    for ( i = 1 ; i < str_ptr[part] ; i++ )
	dsp_msg(" ");
    dsp_msg("^\n");

    str_cnt++;
    return ERR;
}

int	EUP_close(char *file)
{
    static char  pattern[6] ={ 0xfe,0x33,0x00,0x03,0xff,0xff };
    static char  user_call[6] ={ 0xfe,0xff,0xff,0xff,0xff,0xff };

    char    cmd;
    ULINT   i,j;
    FILE    *fp;
    char    *p;
    char    filename[160];

    cmd = eup_buff[buff_ptr-6];
    if ( cmd == 0xf2 )			/* bar_end mark already exist? */
	buff_ptr = buff_ptr - 6;

    end_mark(384);

    ncnv3( buff_ptr - 0x806, 0x800L ); /* set data count */
    ncnv3( 0x300L, buff_ptr ); buff_ptr += 4;

    for ( i=0 ; i<128 ; i++ ) {
	for( j=0 ; j<6 ; j++, buff_ptr++)
	    eup_buff[buff_ptr] = pattern[j];
    }

    ncnv3( 0x300L, buff_ptr ); buff_ptr += 4;

    for ( i=0 ; i<128 ; i++ ){
	for( j=0 ; j<6 ; j++, buff_ptr++)
	    eup_buff[buff_ptr] = user_call[j];
    }

  /* output eup_data to file */

#ifdef	PLAY

    play_misc(eup_buff);
    return FALSE;

#else

    if ( file != NULL )
        strcpy(filename,file);
    else {
	filename[8] = '\0';
        strncpy( filename,&eup_buff[0x20],8);
    }

    if ( (p = strrchr(filename,'\\')) == NULL )
	p = filename;

    if ( strrchr(p,'.') == NULL )
        strcat( filename,".eup" );

    if( (fp = fopen( filename, "wb") ) == NULL )
	return ERR;

    for( i = 0 ; i < buff_ptr ; i++) {
	if( (fputc( eup_buff[i], fp )) == EOF ) {
	    fclose( fp );
	    return ERR;
	}
    }

    fclose( fp );
    return FALSE;
#endif
}
