/*************************************************

u|Iłdtovp}NvZbT

  Making by Master MIYAZAKI  Thanks a lot!!
  custumized by YAMA


*** Eup_de_Pon! v1.00 ***

EupFile : TEST
Title : TEST EUPHONY DATA / BY DARK
Part : 0 1 2 3 4 5 6 7 8 9 10 11 12 13
FmFile : HGFMDAT
PcmFile : RYM_ALL

mac1 = RGRG
mac2 = @103(mac1)

data1 { 1 = 2 = 3 = @1L4O4CDEF ; 12 = (mac2) ; 13 = @1O4RGRG }

data2 {
1  = GAB>C    * This is Sample
12 = CRCR
13 = l8(mac1)(mac2)
}

data1(1)

*** End_of_Pon! v1.00 ***

*************************************************************/
#include    <stdio.h>
#include    <stdlib.h>
#include    <stdarg.h>
#include    <string.h>
#include    <ctype.h>

#define	HIGHC	1

#define	TRUE	1
#define	FALSE	0
#define	ERR	(-1)

#define TMPSIZ  16
#define PARTMAX 16

#define S_NO    256
#define S_MML   257

typedef struct _MAC {
    struct _MAC	*next;
    char	*mac;
    char	*str;
} MACRO;

typedef struct _MML {
    struct _MML *next;
    char	*name;
    char	*part[PARTMAX];
} MMLPTR;

typedef struct {
	char		*eupfile;
    char        *title;
    char        *part;
    char        *fmfile;
    char        *pcmfile;
    MMLPTR      *mml;
} EUPPTR;

extern void EUP_open();
extern int  EUP_send();
extern int  EUP_close();

static int      line=0;
static FILE     *infp=NULL;
static MACRO	*mac_top=NULL;
static int      mml_park=0;
static int      sym_park=0;
static char     *mml_ptr=NULL;
static char	mml_buf[BUFSIZ+1];
static char	str_buf[BUFSIZ];

void	dsp_msg(form,...)
char    *form;
{
    va_list arg;

    va_start(arg,form);
    vfprintf(stderr,form,arg);
}

void	*xmalloc(s)
int	s;
{
    register void *p;

    if ( (p = (void *)malloc(s)) != NULL )
	return p;

    dsp_msg("Memory Alloc Error Abort...\n");
    exit(10);
}

#ifdef	HIGHC
char    *strdup(char *str)
{
    char    *p;

    if ( (p = (char *)xmalloc(strlen(str)+1)) != NULL )
        strcpy(p,str);
    return p;
}
#endif

int     eval(str,ptn)
char	*str;
char	*ptn;
{
    while ( *ptn != '\0' ) {
	if ( toupper(*str) != *ptn )
	    return FALSE;
	str++;
	ptn++;
    }
    return TRUE;
}

int     any(ch,ptn)
int     ch;
char    *ptn;
{
    while ( *ptn != '\0' ) {
	if ( *(ptn++) == ch )
	    return TRUE;
    }
    return FALSE;
}

static void	mac_free()
{
    MACRO   *mc;

    while ( mac_top != NULL ) {
	mc = mac_top->next;
	free(mac_top->mac);
	free(mac_top->str);
	free(mac_top);
	mac_top = mc;
    }
}

static char	*mac_get(str)
char    *str;
{
    static int tmp_cnt=0;
    static char tmp_buf[TMPSIZ][BUFSIZ];
    MACRO   *mc;
    char    *p,*mp,*s,*m;
    char    tmp[80];

    tmp_cnt++; tmp_cnt %= TMPSIZ;
    p = tmp_buf[tmp_cnt];
    mp = p + (BUFSIZ - 1);

    while ( *str != '\0' ) {
	if ( *str == '(' ) {
	    str++;
	    s = tmp;
	    while ( *str != '\0' && *str != ')' && s < &tmp[79] )
		*(s++) = *(str++);
	    *s = '\0';
	    if ( tmp[0] != '\0' && *str == ')' ) {
		mc = mac_top;
		while ( mc != NULL ) {
		    if ( strcmp(mc->mac,tmp) == 0 ) {
			m = mc->str;
			while ( p < mp && *m != '\0' )
			    *(p++) = *(m++);
			break;
		    }
		    mc = mc->next;
		}
		str++;
	    }
	} else if ( p < mp )
	    *(p++) = *(str++);
    }
    *p = '\0';

    return tmp_buf[tmp_cnt++];
}

static int	mac_set(mac,str)
char	*mac;
char	*str;
{
    char    *p;
    MACRO   *mc;

    for ( p = mac ; isalnum(*p) || *p == '_' ; p++ );
    *p = '\0';
    str = mac_get(str);

    mc = mac_top;
    while ( mc != NULL ) {
	if ( strcmp(mc->mac,mac) == 0 )
	    break;
	mc = mc->next;
    }
    if ( mc == NULL ) {
	if ( (mc = (MACRO *)xmalloc(sizeof(MACRO))) == NULL )
	    return ERR;
	mc->mac = strdup(mac);
	mc->next = mac_top;
	mac_top = mc;
    } else
	free(mc->str);

    mc->str = strdup(str);

    return FALSE;
}

static int	mml_getc()
{
    int     ch;

    if ( mml_park != '\0' ) {
	ch = mml_park;
	mml_park = '\0';
	return ch;
    }

    for ( ; ; ) {
	if ( *mml_ptr != '\0' ) {
	    ch = *(mml_ptr++);
	    break;
        }

        if ( (mml_ptr = fgets(str_buf,BUFSIZ,infp)) == NULL )
            return EOF;

	if ( (++line % 100) == 0 )
	    dsp_msg(".");
    }

    return ch;
}

static int	mml_sym()
{
    int     len=0;
    int     ch;

    if ( sym_park != 0 ) {
	ch = sym_park;
	sym_park = 0;
	return ch;
    }

RETRY:
    while ( (ch = mml_getc()) != EOF && isspace(ch) );

    if ( isdigit(ch) ) {
	do {
	    if ( len < BUFSIZ )
		mml_buf[len++] = ch;
	    ch = mml_getc();
	} while ( isdigit(ch) );
	mml_park = ch;
	mml_buf[len] = '\0';
	return S_NO;

    } else if ( ch == '\n' ) {
	goto RETRY;

    } else if ( ch == '*' ) {
        while ( *mml_ptr != '\0' ) mml_ptr++;
        goto RETRY;

    } else if ( any(ch,";{}=") ) {
	return ch;

    } else if ( ch == EOF ) {
	return ERR;

    } else {
	do {
	    if ( len < BUFSIZ && !any(ch," \t") )
		mml_buf[len++] = ch;
	    ch = mml_getc();
	} while ( !any(ch,"\n;{}*=") );
	mml_park = ch;
	mml_buf[len] = '\0';
	return S_MML;
    }
}

static int	mml_set(mp)
MMLPTR 	*mp;
{
    int     sm,no;

    if ( (sm = mml_sym()) == S_NO ) {
	if ( (no = atoi(mml_buf)) < PARTMAX &&
	     (sm = mml_sym()) == '=' &&
	     (sm = mml_set(mp)) == S_MML )
	    mp->part[no] = strdup(mac_get(mml_buf));
	else
	    sm = ERR;
    }
    return sm;
}

static void	mml_free(mp)
MMLPTR  *mp;
{
    int     i;
    MMLPTR  *tp;

    while ( mp != NULL ) {
        tp = mp->next;
        for ( i = 0 ; i < PARTMAX ; i++ ) {
            if ( mp->part[i] != NULL )
                free(mp->part[i]);
        }
	if ( mp->name != NULL )
	    free(mp->name);
	free(mp);
	mp = tp;
    }
}

static MMLPTR	*get_mml(ptr)
char    *ptr;
{
    int     i,sm;
    MMLPTR  *mp;

    if ( (mp = (MMLPTR *)xmalloc(sizeof(MMLPTR))) == NULL )
	return NULL;

    mp->next = NULL;
    for ( i = 0 ; i < PARTMAX ; i++ )
		mp->part[i] = NULL;
    mp->name = NULL;

    mml_ptr = ptr;
    mml_park = '\0';

    if ( *mml_ptr == '{' ) mml_ptr++;

    while ( (sm = mml_set(mp)) != ERR ) {
	if ( sm == '}' )
	    return mp;
	else if ( sm != S_NO && sm != S_MML && sm != ';' )
	    break;
    }

    mml_free(mp);
    return NULL;
}

static MMLPTR	*mml_cpy(tp,name)
MMLPTR  *tp;
char    *name;
{
    int     i;
    MMLPTR  *mp;

    while ( tp != NULL ) {
	if ( strcmp(name,tp->name) == 0 )
	    break;
	tp = tp->next;
    }

    if ( tp == NULL )
	return NULL;

    if ( (mp = (MMLPTR *)xmalloc(sizeof(MMLPTR))) == NULL )
	return NULL;

    mp->next = NULL;
    for ( i = 0 ; i < PARTMAX ; i++ )
	mp->part[i] = (tp->part[i] != NULL ? strdup(tp->part[i]):NULL);
    mp->name = strdup(name);

    return mp;
}

static EUPPTR	*ponpoko()
{
    static char *eupfile=NULL;
    static char *title=NULL;
    static char *part=NULL;
    static char *fmfile=NULL;
    static char *pcmfile=NULL;
    static struct {
	char	*ttl;
	char	**ptr;
    } param[]={
	{ "EUPFILE",	&eupfile },
	{ "TITLE",	&title },
	{ "PART",	&part },
	{ "FMFILE",	&fmfile },
	{ "PCMFILE",	&pcmfile },
	{ NULL,		NULL }
    };
    int     i,cm;
    EUPPTR  *eup;
    MMLPTR  dmy;
    MMLPTR  *mp;
    char    *p,*m;
    char    tmp[BUFSIZ];

    dsp_msg("Pon Macro Convert Start ");

    if ( (eup = (EUPPTR *)xmalloc(sizeof(EUPPTR))) == NULL )
	return NULL;

    eupfile = title = part = fmfile = pcmfile = NULL;

    mp = &dmy;
    mp->next = NULL;

    while ( fgets(str_buf,BUFSIZ,infp) != NULL ) {

	if ( (++line % 100) == 0 )
	    dsp_msg(".");

	if ( (p = strrchr(str_buf,'\n')) != NULL )
	    *p = '\0';

	for ( p = str_buf ; isspace(*p) ; p++ );

	if ( p == '\0' )
	     continue;

	if ( eval(p,"*** END_OF_PON!") )
	    break;

	m = tmp;
	while ( m < &tmp[BUFSIZ-1] && (isalnum(*p) || *p == '_') )
	    *(m++) = *(p++);
	*m = '\0';

	if ( tmp[0] == '\0' )
	    continue;

	while ( isspace(*p) ) p++;

	if ( (cm = *p) == '\0' )
	    continue;

	for ( p++ ; isspace(*p) ; p++);

	if ( cm == '=' ) {
	    mac_set(tmp,p);
	    continue;

	} else if ( cm == '{' ) {
	    if ( (mp->next = get_mml(p)) == NULL )
		goto ERROR;
	    mp->next->name = strdup(tmp);
	    mp = mp->next;
	    continue;

        } else if ( cm == '(' ) {
            if ( (i = atoi(p)) <= 0 ) i = 1;
            while ( isdigit(*p) ) p++;
            while ( isspace(*p) ) p++;
            if ( *(p++) != ')' ) {
                mml_ptr = p;
		goto ERROR;
	    }
            while ( isspace(*p) ) p++;
            if ( *p == '{' ) {
                if ( (mp->next = get_mml(p)) == NULL )
                    goto ERROR;
                mp->next->name = strdup(tmp);
                mp = mp->next;
                i--;
            }
            while ( i-- > 0 ) {
                if ( (mp->next = mml_cpy(dmy.next,tmp)) == NULL ) {
		    mml_ptr = p;
                    goto ERROR;
		}
                mp = mp->next;
            }
            continue;

	} else if ( cm == ':' ) {
	    for ( i = 0 ; param[i].ttl != NULL ; i++ ) {
		if ( eval(tmp,param[i].ttl) &&
		    tmp[strlen(param[i].ttl)] == '\0' ) {
		    if ( *(param[i].ptr) != NULL )
			free(*(param[i].ptr));
		    *(param[i].ptr) = strdup(p);
		    break;
		}
	    }
	    continue;
	}

    }

    eup->eupfile = eupfile;
    eup->title = title;
    eup->part = part;
    eup->fmfile = fmfile;
    eup->pcmfile = pcmfile;
    eup->mml = dmy.next;

    dsp_msg(" End of %d Line\n",line);

    mac_free();
    return eup;

ERROR:
    if ( (p = strrchr(str_buf,'\n')) != NULL ) *p = '\0';
    dsp_msg(" Sintax Error\n");
    dsp_msg("%5d Line : %s\n",line,str_buf);
    dsp_msg("             ");
    for ( p = str_buf ; *p != '\0' && p < mml_ptr ; p++ )
	dsp_msg(" ");
    dsp_msg("^\n");

    free(eup);
    mml_free(dmy.next);
    mac_free();
    return NULL;
}

void	eup_free(eup)
EUPPTR	*eup;
{
    if ( eup == NULL )
	return;
    if ( eup->eupfile != NULL ) free(eup->eupfile);
    if ( eup->title != NULL ) free(eup->title);
    if ( eup->part != NULL ) free(eup->part);
    if ( eup->fmfile != NULL ) free(eup->fmfile);
    if ( eup->pcmfile != NULL ) free(eup->pcmfile);
    mml_free(eup->mml);
}

EUPPTR	*get_pon(fp)
FILE	*fp;
{
    infp = fp;

    while ( fgets(str_buf,BUFSIZ,infp) != NULL ) {
	line++;
	if ( eval(str_buf,"*** EUP_DE_PON!") )
	    return ponpoko();
    }
    return NULL;
}

static int Pon_Compile(fp)
FILE	*fp;
{
    int     blk;
    int     pt[14];
    EUPPTR  *eup;
    MMLPTR  *mp;

    if ( (eup = get_pon(fp)) == NULL )
	return ERR;

    if ( eup->eupfile == NULL )
	eup->eupfile = strdup("SAMPLE");

    if ( eup->part == NULL )
	eup->part = strdup("0 1 2 3 4 5 6 7 8 9 10 11 12 13");

    sscanf( eup->part, "%d %d %d %d %d %d %d %d %d %d %d %d %d %d",
	    &pt[0], &pt[1], &pt[2], &pt[ 3], &pt[ 4], &pt[ 5], &pt[ 6],
	    &pt[7], &pt[8], &pt[9], &pt[10], &pt[11], &pt[12], &pt[13] );

    dsp_msg("%s.EUP Compile Start ",eup->eupfile);

    EUP_open( eup->title, eup->eupfile, pt, eup->fmfile, eup->pcmfile );

    blk = 0;
    mp = eup->mml;
    while ( mp != NULL ) {
	if ( (++blk % 10) == 0 )
	    dsp_msg(".");
	if ( EUP_send( mp->part ) )
	    goto ERROR;
	mp = mp->next;
    }
    dsp_msg(" End of %d Block\n",blk);

    if ( EUP_close(NULL) ) {
	dsp_msg(" File I/O error\n");
	goto ERROR;
    }

    eup_free(eup);
    return FALSE;

ERROR:
    eup_free(eup);
    return ERR;
}

void	Pon_de_Eup(file)
char	*file;
{
    FILE    *fp;

    if ( (fp = fopen(file,"r")) == NULL ) {
	dsp_msg("Can't open %s\n",file);
	return;
    }

    dsp_msg("Check of %s File....\n",file);

    line = 0;
    while ( Pon_Compile(fp) == FALSE );
    fclose(fp);
}
int	main(argc,argv)
int     argc;
char    *argv[];
{
    dsp_msg("Pon to Eup Compiler Version 1.02\n");
    dsp_msg("Copyleft (c) 1990 Nifty TOWNS Forum YAMA&Ken\n\n");

    if ( argc <= 1 ) {
	while ( Pon_Compile(stdin) == FALSE );
    }

    else {
	while ( --argc > 0 )
	    Pon_de_Eup(*(++argv));
    }

    return 0;
}
